#include "BinaryTree.h"
#include "BinarySearchTree.h"

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void printint( int& item )
{
    cout << item << " ";
}

int compint( int& left, int& right )
{
    return left - right;
}


void main()
{
    cout << "======================================================" << endl;
    cout << "Trees Part II" << endl;
    cout << "Demo 01: Binary Seach Tree Demo" << endl;
    cout << "Compiled " << __DATE__ << " by Ron Penton" << endl;
    cout << "======================================================" << endl << endl;
    cout << "NOTE: when inserting large volumes of numbers into the" << endl;
    cout << "      tree, the output routine slows the algorithm" << endl;
    cout << "      significantly, so use 'no echo' insertion for" << endl;
    cout << "      large amounts of numbers. My Duron 600MHz can" << endl;
    cout << "      insert 100,000 numbers in about 1 second ." << endl;

    cout << endl;
    cout << "Press any key to continue..." << endl;
    getchar();


    BinarySearchTree<int> tree( compint );
    srand( (unsigned)time( NULL ) );

    int choice;

    int temp;
    int x;
    int y;

    while( 1 )
    {
        cout << "==================================================" << endl;
        cout << "    1 - Insert Item" << endl;
        cout << "    2 - Find Item" << endl;
        cout << "    3 - Remove Item" << endl;
        cout << "    4 - Get Count" << endl;
        cout << "    5 - Get Depth of root" << endl;
        cout << "    6 - Inorder Traversal" << endl;
        cout << "    7 - Iterative Inorder Traversal" << endl;
        cout << "    8 - preorder (used to find structure of tree)" << endl;
        cout << "    9 - Fill with random values" << endl;
        cout << "   10 - Fill with random values (no echo)" << endl;
        cout << "==================================================" << endl;
        cout << "Enter operation to perform ('0' to quit): ";
        cin >> choice;
        if( choice == 0 )
            break;

        switch( choice )
        {
        case 1:
            cout << "Enter number to insert: ";
            cin >> temp;
            tree.insert( temp );
            break;

        case 2:
            cout << "Enter number to find: ";
            cin >> temp;
            if( tree.has( temp ) )
                cout << "The tree has " << temp << ".";
            else
                cout << "The tree does not have " << temp << ".";
            break;

        case 3:
            cout << "Enter number to remove: ";
            cin >> temp;
            if( tree.remove( temp ) )
                cout << temp << " was successfully removed.";
            else
                cout << "The tree does not contain " << temp << "!";
            break;

        case 4:
            cout << "The tree has " << tree.count() << " items.";
            break;

        case 5:
            cout << "The depth of the root is " << tree.depth() << ".";
            break;

        case 6:
            cout << "The tree contains: ";
            tree.inorder( printint );
            cout << endl;
            break;

        case 7:
            cout << "The tree contains: ";
            tree.inorderIterative( printint );
            cout << endl;
            break;

        case 8:
            cout << "The tree contains: ";
            tree.preorder( printint );
            cout << endl;
            break;

        case 9:
            cout << "Enter number of items to insert: ";
            cin >> temp;
            for( x = 0; x < temp; x++ )
            {
                y = (rand() % 4096) - 2048;
                cout << "inserting " << y << "..." << endl;
                tree.insert( y );
            }
            break;


        case 10:
            cout << "Enter number of items to insert: ";
            cin >> temp;
            cout << "Inserting..." << endl;
            for( x = 0; x < temp; x++ )
            {
                y = (rand() % 4096) - 2048;
                tree.insert( y );
            }
            break;

        default:
            cout << "INVALID INPUT" << endl;
        }
        cout << endl;
        cout << "Press any key to continue..." << endl;
        getchar();
    }
}
